# What works:

## REST API

### Auth:
* [x] Create session (user, social provider, firebase phone);
* [x] Delete session (current, by id, except current);
* [x] Get session;
* [x] Sign in (user, login/email, providers, firebase phone);

### Users:
* [x] Get user (id, identifiers);
* [x] Get users (identifiers, filters, sorting, additional params);
* [x] Create user;
* [x] Update user;
* [x] Delete user (id, external id);
* [x] Upload Address Book;
* [x] Get Address Book;
* [x] Get registered users from Address Book;
* [x] Reset password;

### Chat:
* [x] Dialogs:
    - [x] Create dialog;
    - [x] Update dialog (name, description, avatar, occupants, admins, pinned messages, enable/disable notifications);
    - [x] Subscribe/Unsubscribe PUBLIC dialogs;
    - [x] Get dialogs;
    - [x] Get dialogs count;
    - [x] Get dialogs occupants;
    - [x] Delete dialog(s);
* [x] Messages:
    - [x] Create message;
    - [x] Update message (body, mark delivered, mark read);
    - [x] Get message;
    - [x] Get messages count;
    - [x] Get unread messages count;
    - [x] Delete message;
* [x] Global search;


### Push notifications:
* [x] Create event;
* [x] Create subscription;
* [x] Get subscriptions;
* [x] Delete subscription;

### Storage:
* [x] Create/Upload file;
* [x] Delete file;
* [x] Update file;
* [x] Get file;
* [x] Download file (just get public/private url);

### Custom objects:
* [ ] Base CGUD requests;

## Realtime API
* [ ] Chat communications:
    - [x] Login/logout;
    - [x] Send group/private messages;
    - [x] Receive group/private messages;
    - [x] Join/leave group chats;
    - [x] Send/receive system messages;
    - [x] Send/receive typing statuses;
    - [x] Send/receive deliver/read status;
    - [x] Get last user activity;
    - [ ] Delete messages;
    - [ ] Edit messages;
    - [x] Self-destroy messages;
    - [ ] Stream management;
    - [ ] Reconnection manager;
    - [ ] Ping manager;
    - [ ] etc...;


* [ ] Video chatting;

* [ ] Conference calling;

* [ ] Live video streaming;
