import 'package:xmpp_stone/xmpp_stone.dart';

import '../../../../connectycube_core.dart';

import 'chat_messages_manager.dart';
import 'base_managers.dart';
import 'messages-statuses-manager.dart';
import 'system_messages_manager.dart';
import 'typing_statuses_manager.dart';

class GlobalMessagesManager extends Manager {
  static Map<Connection, GlobalMessagesManager> _instances = Map();
  MessageHandler _messageHandler;

  GlobalMessagesManager._private(Connection connection) : super(connection) {
    _messageHandler = MessageHandler.getInstance(connection);
    _messageHandler.messagesStream.where((messageStanza) {
      return !SystemMessagesManager.getInstance(connection)
              .acceptMessage(messageStanza) &&
          !TypingStatusesManager.getInstance(connection)
              .acceptMessage(messageStanza) &&
          !MessagesStatusesManager.getInstance(connection)
              .acceptMessage(messageStanza) &&
          !ChatMessagesManager.getInstance(connection)
              .acceptMessage(messageStanza);
    }).listen((messageStanza) {
      onReceiveNewMessageStanza(messageStanza);
    });
  }

  static getInstance(Connection connection) {
    GlobalMessagesManager manager = _instances[connection];
    if (manager == null) {
      manager = GlobalMessagesManager._private(connection);
      _instances[connection] = manager;
    }

    return manager;
  }

  void onReceiveNewMessageStanza(MessageStanza messageStanza) {
    log('Receive unknown type message stanza');
  }
}
