import 'auth/models/cube_session.dart';

class CubeSessionManager {
  static final CubeSessionManager _instance = CubeSessionManager._internal();

  CubeSessionManager._internal();

  static CubeSessionManager get instance => _instance;

  CubeSession activeSession;

  void saveActiveSession(CubeSession session) {
    this.activeSession = session;
  }

  CubeSession getActiveSession() {
    if (isActiveSessionValid()) return activeSession;

    return null;
  }

  bool isActiveSessionValid() {
    return activeSession != null && !isSessionExpired(activeSession);
  }

  bool isSessionExpired(CubeSession cubeSession) {
    if (cubeSession == null) return true;

    DateTime expirationDate = cubeSession.tokenExpirationDate;
    DateTime currentDate = DateTime.now();

    return expirationDate == null || expirationDate.isBefore(currentDate);
  }

  void updateActiveSession() {}

  String getToken() {
    return activeSession == null ? "" : activeSession.token;
  }

  void setToken(String token) {
    if (activeSession != null) {
      activeSession.token = token;
    }
  }

  DateTime getTokenExpirationDate() {
    return activeSession == null ? null : activeSession.tokenExpirationDate;
  }

  void setTokenExpirationDate(DateTime tokenExpirationDate) {
    if (activeSession != null) {
      activeSession.tokenExpirationDate = tokenExpirationDate;
    }
  }

  void deleteActiveSession() {
    activeSession = null;
  }
}
