import '../../rest/query/query.dart';
import '../../rest/request/rest_request.dart';
import '../../utils/consts.dart';

class ResetPasswordQuery extends Query<void> {
  String _email;

  ResetPasswordQuery(this._email);

  @override
  setMethod(RestRequest request) {
    request.method = RequestMethod.GET;
  }

  @override
  setUrl(RestRequest request) {
    request.setUrl(buildQueryUrl([USERS_ENDPOINT, PASSWORD, RESET]));
  }

  @override
  setParams(RestRequest request) {
    super.setParams(request);

    request.params[EMAIL] = _email;
  }

  @override
  void processResult(String responseBody) {}
}
